From 839feea1c683a4d7e0d3fa8cd08f174c844942a3 Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 11 2017 13:41:02 +0000
Subject: [PATCH 10/51] add prerequisite decorator


This lets the linter skip checks that would inevitably fail because of a
more fundamental problem. E.g. if the license block is missing there is
no need to perform checks on the module license block.

The argument to the decorator is the name of the method or methods which
are prerequisite to the decorated method, with or without the "lint_"
prefix.

---

diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
index d522a2c..d69cb3d 100644
--- a/src/_fedmod/modulemd_linter.py
+++ b/src/_fedmod/modulemd_linter.py
@@ -60,6 +60,27 @@ class detail(object):
         return fn
 
 
+class prerequisite(object):
+    """Decorate a linter method with what checks are a prerequisite so as to
+    not overwhelm a user with subsequent errors."""
+
+    def __init__(self, *prerequisites):
+        assert len(prerequisites)
+
+        # Allow specification with and without "lint_" prefix
+        prerequisites = set(x if x.startswith("lint_") else "lint_" + x
+                            for x in prerequisites)
+
+        self.prerequisites = prerequisites
+
+    def __call__(self, fn):
+        try:
+            fn.lint_prerequisites.update(self.prerequisites)
+        except AttributeError:
+            fn.lint_prerequisites = self.prerequisites
+        return fn
+
+
 class ModuleMDLinter(object):
     """Linter for modulemd YAML files or data."""
 
@@ -98,8 +119,20 @@ class ModuleMDLinter(object):
                    for x in lint_methods)
 
         flagged = []
+        failed_or_skipped = set()
 
         for method in lint_methods:
+            skip_check = False
+
+            for prerequisite in getattr(method, 'lint_prerequisites', ()):
+                if prerequisite in failed_or_skipped:
+                    skip_check = True
+                    failed_or_skipped.add(method.__name__)
+                    break
+
+            if skip_check:
+                continue
+
             try:
                 method()
             except Exception as e:
@@ -109,6 +142,7 @@ class ModuleMDLinter(object):
                     lint_detail = None
                 flagged.append((method.lint_level, inspect.getdoc(method),
                                 lint_detail, method.lint_guidelines_url, e))
+                failed_or_skipped.add(method.__name__)
 
         for i, (lvl, text, detail, url, exc) in enumerate(flagged):
             print("[{lvl}] {url}".format(lvl=lvl.upper(),
@@ -135,6 +169,7 @@ class ModuleMDLinter(object):
 
     @error
     @guidelines_link('#Module_summary_and_description')
+    @prerequisite('summary_exists')
     def lint_summary_one_sentence(self):
         """The module summary is a one sentence concise description of the
         module."""
@@ -142,6 +177,7 @@ class ModuleMDLinter(object):
 
     @warning
     @guidelines_link('#Module_summary_and_description')
+    @prerequisite('summary_exists')
     def lint_summary_no_trailing_period(self):
         """The summary SHOULD NOT end in a period."""
         assert not self.mmd.summary.strip().endswith(".")
@@ -154,6 +190,7 @@ class ModuleMDLinter(object):
 
     @warning
     @guidelines_link('#Module_summary_and_description')
+    @prerequisite('description_exists')
     def lint_description_ends_in_period(self):
         """The description SHOULD end in a period."""
         assert self.mmd.description.strip().endswith(".")
@@ -167,6 +204,7 @@ class ModuleMDLinter(object):
     @error
     @guidelines_link('#Module_licensing')
     @detail("The license block must be a dictionary (key/value).")
+    @prerequisite('license_block_exists')
     def lint_license_block_keys(self):
         """Every module MUST contain a license block."""
         assert isinstance(self.yaml_data['license'], dict)
@@ -174,6 +212,7 @@ class ModuleMDLinter(object):
     @error
     @guidelines_link('#Module_licensing')
     @detail("The module license block must exist.")
+    @prerequisite('license_block_keys')
     def lint_license_module_block_exists(self):
         """Every module MUST contain a license block and declare a list of
         the module's licenses."""
@@ -182,6 +221,7 @@ class ModuleMDLinter(object):
     @error
     @guidelines_link('#Module_licensing')
     @detail("The module license block must be a list.")
+    @prerequisite('license_module_block_exists')
     def lint_license_module_block_is_list(self):
         """Every module MUST contain a license block and declare a list of
         the module's licenses."""
@@ -190,6 +230,7 @@ class ModuleMDLinter(object):
     @error
     @guidelines_link('#Module_licensing')
     @detail("The content license block must be a list if it exists.")
+    @prerequisite('license_block_keys')
     def lint_license_content(self):
         """The packager MAY also define a list of content licenses."""
         if 'content' in self.yaml_data['license']:

